package zdb

import (
	"fmt"
	"github.com/jackc/pgx/v5/pgxpool"
)

type conn struct {
	*pgxpool.Pool

	Mode  connMode
	Alive bool
}

type connMode int

const (
	ConnModeMaster connMode = iota
	ConnModeSync
	ConnModeAsync
)

func (c connMode) String() string {
	switch c {
	case ConnModeMaster:
		return "master"
	case ConnModeSync:
		return "sync"
	case ConnModeAsync:
		return "async"
	default:
		return "unknown"
	}
}

func (c conn) ToString() string {
	return fmt.Sprintf("%s: %s:%d", c.Mode, c.Config().ConnConfig.Host, c.Config().ConnConfig.Port)
}
